package com.logicbig.example;

import com.logicbig.util.RandomUtil;
import java.util.Hashtable;

public enum TradingProjectDataService {
    instance;
    private final String ROLES[] =
            {"Project Manager", "Tech Lead", "Developer", "Scrum Master", "Business Analyst"};
    private Hashtable<Object, Object> modules = new Hashtable<>();

    TradingProjectDataService() {
        addModule("Trading", "Real Time Trading", "Order System");
        addModule("Future/Option", "Option Analyzer", "Market Scanning System");
        addModule("Fixed Income", "Bond Tool", "Price/Yield Calculator",
                "Strategy Evaluator");
    }

    private void addModule(String module, String... projects) {
        for (String project : projects) {
            modules.put(module, getProject(module, project));
        }
    }

    private Object getProject(String module, String project) {
        Hashtable<Object, Object> projectMap = new Hashtable<>();
        projectMap.put(project, getEmployeesForProject(module, project));
        return projectMap;
    }

    private Object getEmployeesForProject(String module, String project) {
        //random example employees, in real app we will get it from backend
        String[] employees = new String[ROLES.length];
        for (int i = 0; i < ROLES.length; i++) {
            employees[i] = RandomUtil.getFullName() + " [" + ROLES[i] + "]";
        }
        return employees;
    }

    public Hashtable<?, ?> getProjectHierarchy() {
        return modules;
    }
}